
/*
  - Formularz RESET
  - Formularz dla IP lokalnego
  - Formularz do IP zdalnego

  - Forularz do wysylania ramki do ORNO (liczenie CRC) i okno prezentacji wyniku (wszystko w HEX)
  - Forularz do prametrów transmisji formatu ramki

  - rejestr 110. Ustawienie stałej licznika (LED). Domyslne 1000, akceptowane 100, 1000, 2000. ustawic na 100
*/


//todo: zapis na thing spoeak i lokalny (co 10 sek) z usrednonych wynikow


#define _WEMOS          1    // 0-D1, 1-MINI


//#define DEBUG_UART0     // Część informacji na serial (USB) więc także na RS485 (ale DIR nieaktywny). INFO: wylaczajac mozna skrócić czas CO_ILE_PYTAC_ORNO
#define DEBUG_UART1
//#define DEBUG_SOFT         // Informacje na software serial. INFO: Moze wymagac zwiekszenia CO_ILE_PYTAC_ORNO
#define BAUD_DEBUG      921600
//
//#define DEBUG_MODBUS    // Info o przychodzacych ramkach modbus
//#define DEBUG_RTC
//#define DEBUG_URL       // Info o wysylaniu danych na serwer
//#define DEBUG_PRINT_REP_WWW


#define MODBUS_HEX_ALL  // Rejestrowanie (CSV) wszystkich ramek MODBUS odczytu mocy (gdy zakomentowane tylko gdy moc > MAX_MOC_CZYNNA
#define MAX_MOC_CZYNNA  10000UL


#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
WiFiUDP Udp;
#include <ThingSpeak.h>

#include <SoftwareSerial.h>
#ifdef DEBUG_SOFT
SoftwareSerial mySerial( D3, D4 ); // RX, TX - GPIO0 GPIO2
#endif

#include <NtpClientLib.h>     // NTP
#include <TimeLib.h>          // NTP

//#include <Crc16.h> //Crc 16 library (XModem)    // INFO: ta biblioteka jest trefna, wywoluje blad stosu. Dalem funkcję liczaczą CRC "na piechote"
//Crc16 crc16;

#include "EEPROM.h"
#include "ansi.h"


//----- Ustawienia UART -----//
#define DIR485    D2
#define BAUD    9600
#define FORMAT_UART_514  SERIAL_8E1
#define FORMAT_UART_504  SERIAL_8N1


//----- Ustawienia sieci -----//
#define DHCP    // uzycie definicji wlacza DHCP
#define WIFI_SSID   "id"         // Uzupełnić !!!
#define WIFI_PASS   "pass"    // Uzupełnić !!!


#ifndef DHCP        // Gdy nie wlaczone DHCP
IPAddress staticIP(192, 168, 0, 101);   // Uzupełnić !!!
IPAddress gateway(192, 168, 0, 1);      // Uzupełnić !!!
IPAddress subnet(255, 255, 255, 0);     // Uzupełnić !!!
#endif


#define LICZBA_HOSTOW       4
#define DATA_HOST_LOCAL_1    "192.168.0.100"      // IP lokalnego serwera                   // Uzupełnić !!!
#define DATA_HOST_LOCAL_2   "" // "192.168.0.150"      //IP lokalnego serwera                    // Uzupełnić !!!
#define DATA_HOST_REMOTE_1  "domane_lub_ip.pl"     //IP serwera, może byc nazwa domenowa     // Uzupełnić !!!
#define DATA_HOST_REMOTE_2  "domane_lub_ip2.pl"     //IP serwera, może byc nazwa domenowa     // Uzupełnić !!!
#define LOGGER_URL          "/logo/logger.php?"     // 192.168.2.15/automatyka/dataLogger.php?moc=123&pf=1.0&id=30
#define REPLY_WWW         // definicja zalacza oczekiwanie na odpowiedz z serwera UWAGA!!! gdy nie ma czekania to wyslanie kolejnego GET nie powiedzie sie gdy brak pauzy
#define OVERTIME_REPLY_WWW   200   // max czas czekania na odpowiedz z WWW

#define BROADCAST   "192.168.0.255"
unsigned int localUdpPort = 2102;


//dane konta na thingspeak
const char * thingspeak_apiKey_1 = "key"; // sasedw - sas@elportal.pl                 // Uzupełnić !!!
const char * thingspeak_apiKey_2 = "key2"; // rmikliczniki - rmik@interia.eu     // Uzupełnić !!!
unsigned long thingspeak_myChannelNumber = 1;
// "184.106.153.149" lub api.thingspeak.com
const char* server = "api.thingspeak.com";
WiFiClient client_thingspeak;


// #define DELAY_DIR         // Deklaracja wlacza pauze przed i po nadaniu ramki (przydatne gdy nie ma terminowalinia linii z polaryzacją)
#define TIM_SEND_BYTE_UART    1200    // Czas [us] nadawania bajtu przez UART
#define DEF_RESTART_WIFI    (5 * 60 * 10000)  // 5 minut
#define TIM_OFLINE_ORNO   	20000UL   // czas braku odpowiedzi uznawany za awarie
#define DEF_BUSY_ACK_ORNO    100UL
#define PAZUZA_ZAPYTAN_ORNO   5000UL  // Pauza pomiedzy seriami
#define CO_ILE_PYTAC_ORNO    250UL   // Pauzy w serii pytan 100 * (8+1 na RTC). Min 100ms bez debug, 200ms DEBUG_USART0, 300ms gdy DEBUG
#if !defined( DEBUG_SOFT ) && !defined( DEBUG_UART0 ) && !defined( DEBUG_UART1 )
#undef CO_ILE_PYTAC_ORNO
#define CO_ILE_PYTAC_ORNO   150
#endif
#define TIM_NEXT_TEST_TYPU    5000UL  // po jakim czasie zmienic typ testowanego licznika
#define LICZBA_PYTAN_ORNO   8


#define Co_ILE_NA_THINGSPEAK    60000UL
#define Co_ILE_NA_UDP       5000UL    // todo: 5 sek
#define Co_ILE_NA_URL         10000UL
#define Co_ILE_NA_URL_LOCAL_HOST  6


#define CO_ILE_NTP          123
#define CO_ILE_PRINT_CZAS   66000UL


#if _WEMOS == 0
#define LED_PIN_R   D15
#define LED_PIN_Y   D8
#define LED_PIN_G   D7
#define LED_PIN_B   D14
// D2 - DIR
// D9 - UART 1
#define LED_PIN_SCK   D13
#elif _WEMOS == 1
#define LED_PIN_R   D0
#define LED_PIN_Y   D5
#define LED_PIN_G   D6
#define LED_PIN_B   D7
// D2 - DIR
// D4 (GPIO2) - UART 1
#else
#error "Wybierz plytke"
#endif

WiFiServer localServer(8888);
WiFiClient localClient;
uint8_t ip[4];
uint16_t typOrno = 504;
uint8_t ustalonyTypLicznika = false;
//uint8_t xxxx __attribute__ ((section (".noinit")));
#define LEN_ODP_ORNO    (2+16*2+2)
uint8_t fl_bzdura, BufOdpOrno[LEN_ODP_ORNO];


uint16_t Napiecie, WspolczynnikMocy, Czestotliwosc;
uint32_t Prad, MocCzynna, MocBierna, MocPozorna, EnergiaCzynna, EnergiaBierna;
uint32_t CzasDoResetu, CzasDoRstWifi, timeoutAskOrno, timeoutBusyOrno;
uint32_t TimLoop, TimLoopMax;
bool fl_WriteRTC, ornoOnLine;
uint8_t rdORNOfull;
int8_t static nrPytaniaOrno = -1;
uint32_t CzasDoTHINGSPEAK, CzasDoURL;
uint32_t timOdpowiedziOrno, czasOdpowiedziOrno, czasTransmisjiOrno, timAktywnyTunel;


uint16_t dtYYYY;
uint8_t dtMIES, dtDD, dtGG, dtMM, dtSS;


struct ee {
  uint32_t id;
  int typLicznika;
  bool fl_OrnoOn;
  bool fl_ThingOn;
} ee;


//===========================================================
void eeWrite() {
#define EE_ID 0x00776445    // Ciazg EdW (od końca) zanonczony ZEREM

  ee.id = EE_ID;

  //----- Zapis struktury w EEprom
  uint8_t tab[ sizeof(ee) ];
  memcpy( tab, &ee, sizeof(ee) ); // struktura do tablicy
  EEPROM.begin( sizeof(ee) );
  delay(10); //todo: czy to potrzebne ?
  for (word e = 0; e < sizeof(ee); e++) EEPROM.write( e, tab[e] );
  EEPROM.commit();
  EEPROM.end();


  char txt[50];
  printDebug( ANSI_PEN_YELLOW"\n\rWrite EEprom: "ANSI_PEN_WHITE );
  for (word x = 0; x < sizeof(ee); x++ ) {
    sprintf( txt, "%02x ", tab[x] ); printDebug( txt );
  }
}


//------------------------------------------------------------
void eeRead() {
  //----- Odczyt struktury z EEprom
  EEPROM.begin( sizeof(ee) );
  delay(10); //todo: czy to potrzebne ?
  uint8_t tab[ sizeof(ee) ];
  for (word e = 0; e < sizeof(ee); e++) tab[e] = EEPROM.read( e );
  EEPROM.end();
  memcpy( &ee, tab, sizeof(ee) ); // tablica do struktury

  if ( ee.id != EE_ID ) {
    ee.fl_OrnoOn = true;
    ee.fl_ThingOn = true;
    eeWrite();
    printDebug( ANSI_PEN_YELLOW"\n\r*** Init CFG ***"ANSI_PEN_WHITE );
  }
  else printDebug( ANSI_PEN_GREEN"\n\r*** CFG OK ***"ANSI_PEN_WHITE );


  char txt[50];
  printDebug( "\n\rRead EEprom: ");
  for (word x = 0; x < sizeof(ee); x++ ) {
    sprintf( txt, "%02x ", tab[x] ); printDebug( txt );
  }
  sprintf( txt, "\n\r$%x ", ee.id ); printDebug( txt );
  sprintf( txt, " %d ", ee.typLicznika ); printDebug( txt );
  sprintf( txt, " %x ", ee.fl_OrnoOn ); printDebug( txt );
  sprintf( txt, " %x ", ee.fl_ThingOn ); printDebug( txt );
}


//===========================================================
enum { LED_R, LED_Y, LED_G, LED_B, LED_SCK,
       LED_END
     };
uint32_t timLed[ LED_END ];
bool fl_LedBlink[ LED_END ];
uint16_t timLedBlink[ LED_END ];
//------------------------------------------------------------
void LedOn( byte nr ) {
  switch ( nr ) {
    case LED_R: digitalWrite( LED_PIN_R, LOW ); fl_LedBlink[ LED_PIN_R ] = false; break;
    case LED_Y: digitalWrite( LED_PIN_Y, LOW ); fl_LedBlink[ LED_PIN_Y ] = false; break;
    case LED_G: digitalWrite( LED_PIN_G, LOW ); fl_LedBlink[ LED_PIN_G ] = false; break;
    case LED_B: digitalWrite( LED_PIN_B, LOW ); fl_LedBlink[ LED_PIN_B ] = false; break;
#if _WEMOS == 0
    case LED_SCK: digitalWrite( LED_PIN_SCK, LOW ); fl_LedBlink[ LED_PIN_SCK ] = false; break;
#endif
  }
}


//------------------------------------------------------------
void LedOff( byte nr ) {
  switch ( nr ) {
    case LED_R: digitalWrite( LED_PIN_R, HIGH ); timLed[LED_R] = 0; fl_LedBlink[ LED_PIN_R ] = false; break;
    case LED_Y: digitalWrite( LED_PIN_Y, HIGH ); timLed[LED_Y] = 0; fl_LedBlink[ LED_PIN_Y ] = false; break;
    case LED_G: digitalWrite( LED_PIN_G, HIGH ); timLed[LED_G] = 0; fl_LedBlink[ LED_PIN_G ] = false; break;
    case LED_B: digitalWrite( LED_PIN_B, HIGH ); timLed[LED_B] = 0; fl_LedBlink[ LED_PIN_B ] = false; break;
#if _WEMOS == 0
    case LED_SCK: digitalWrite( LED_PIN_SCK, HIGH ); timLed[LED_SCK] = 0; fl_LedBlink[ LED_PIN_SCK ] = false; break;
#endif
  }
}


//------------------------------------------------------------
void LedChg( byte nr ) {
  switch ( nr ) {
    case LED_R: digitalWrite(LED_PIN_R, !digitalRead(LED_PIN_R)); timLed[LED_R] = 0; break;
    case LED_Y: digitalWrite(LED_PIN_Y, !digitalRead(LED_PIN_Y)); timLed[LED_Y] = 0; break;
    case LED_G: digitalWrite(LED_PIN_G, !digitalRead(LED_PIN_G)); timLed[LED_G] = 0; break;
    case LED_B: digitalWrite(LED_PIN_B, !digitalRead(LED_PIN_B)); timLed[LED_B] = 0; break;
#if _WEMOS == 0
    case LED_SCK: digitalWrite(LED_PIN_SCK, !digitalRead(LED_PIN_SCK)); timLed[LED_SCK] = 0; break;
#endif
  }
}


//------------------------------------------------------------
void SterujLedy() {
  /*
    //----- Miganie diody RUN -----//
    uint32_t static tim;
    if ( millis() > tim ) {
    tim = millis() + 500;
    digitalWrite(LED_PIN_B, !digitalRead(LED_PIN_B)); //todo: uzyc ledBlink w setup
    }
  */

  for ( byte x = 0; x < LED_END; x++) {
    if ( ! fl_LedBlink[ x ] ) {   // Nie ma blink
      if ( timLed[ x ] ) {        // Jesli flash wlaczony
        if ( millis() >= timLed[ x ] ) LedOff( x );
      }
    }
    else {        // Blink
      if ( millis() >= timLed[ x ] ) {
        LedChg( x );
        timLed[ x ] = millis() + timLedBlink[ x ];
      }
    }
  }
}


//------------------------------------------------------------
void LedFlash( byte nr, uint16_t czas ) {
  if ( nr < LED_END ) {
    timLed[ nr ] = millis() + 50;
    LedOn( nr );
    fl_LedBlink[ nr ] = false;
  }
}


//------------------------------------------------------------
void LedBlink( byte nr, uint16_t czas ) {
  if ( nr < LED_END ) {
    timLedBlink[ nr ] = czas;
    fl_LedBlink[ nr ] = true;
  }
}


//------------------------------------------------------------


char static buf[10000]; // todo: zrobic kontrole przekroczenia bufora
//------------------------------------------------------------
#include "ESP8266WebServer.h"
ESP8266WebServer  webServer(80);
//===========================================================
void IndexHandler()
{
  //  webServer.send("Location", "/index.html",true );  // przekierowanie na plik w SPIFFS
  //  webServer.send( 302,"text/plane" );    //EP 2018-12 str 31

  //  webServer.send( 200, "text/plain", "Czas uruchomienia " + String( millis()) + "ms" );


  char txt[200];//1111111111222222222233333333334444444444555555555566666666667777777777888888888899999999990000000000


  //  strcpy( buf, "<head> <title>Licznik ORNO</title> <meta http-equiv='refresh' content='5' /> </head>" );  // Firefox burzy sie na 'refresh'
  strcpy( buf, "<head> <title>Licznik ORNO</title> </head>" );

  if ( ornoOnLine ) {
    if ( typOrno == 514 ) strcat( buf, "<H3>Licznik ORNO 514 " );
    else strcat( buf, "<H3>Licznik ORNO 504 " );
  }
  else { // Licznik nieodpowiada
    strcat( buf, "<H3>Licznik ORNO <font color='RED'>xxx </font>" );
  }

  if ( ip[3] == 52 ) strcat( buf, "<font color='BLUE'>(Glowny) </font>" );
  else if ( ip[3] == 53 ) strcat( buf, "<font color='BLUE'>(Warsztat) </font>" );
  else if ( ip[3] == 54 ) strcat( buf, "<font color='BLUE'>(Przenosny) </font>" );
  char kolor[30] = "<font color='BLACK'>";
  if ( ornoOnLine ) {
    if ( rdORNOfull >= LICZBA_PYTAN_ORNO ) {
      strcat( buf, "<font color='GREEN'> <B>RS485 ON-Line</B></font>" );
      strcpy( kolor, "<font color='GREEN'>" );
    }
    else {
      strcat( buf, "<font color='ORANGE'> <B>RS485 ON-Line</B></font>" );
      strcpy( kolor, "<font color='ORANGE'>" );
    }
  }
  else {
    strcat( buf, "<font color='RED'> <B>RS485 OFF-Line</B></font>" );
    strcpy( kolor, "<font color='RED'>" );
  }
  strcat( buf, " <A HREF='fw'>FW</A></H3>\r" );


  uint32_t EnergiaCzynnaSyncZE = EnergiaCzynna + 1867.7 * 1000; // Dodajemy wskazanie licznika ZE // todo: zrobic w formularzu, zapis do EEPROM
  EnergiaCzynnaSyncZE -= 3820; // Wskazanie ORNO // todo: forularz
  strcat( buf, "<TABLE cellspacing='10' cellpadding='5'> <tr style='vertical-align: top; '><TD>\r" );
  strcat( buf, kolor );
  sprintf( txt, "P = %d,%03dkW", MocCzynna / 1000, MocCzynna % 1000 ); strcat( buf, txt );
  sprintf( txt, "<BR>P bierna = %d,%03dkWAr", MocBierna / 1000, MocBierna % 1000 ); strcat( buf, txt );
  sprintf( txt, "<BR>P pozorna = %d,%03dkWA", MocPozorna / 1000, MocPozorna % 1000 ); strcat( buf, txt );
  sprintf( txt, "<BR>Cos Fi = %d,%03d", WspolczynnikMocy / 1000, WspolczynnikMocy % 1000  ); strcat( buf, txt );
  strcat( buf, "</TD><TD>\r" );
  strcat( buf, kolor );
  sprintf( txt, "U = %d,%02dV", Napiecie / 100, Napiecie % 100  ); strcat( buf, txt );
  sprintf( txt, "<BR>I = %d,%03dA", Prad / 1000, Prad % 1000 ); strcat( buf, txt );
  sprintf( txt, "<BR>f = %d,%02dHz", Czestotliwosc / 100, Czestotliwosc % 100 ); strcat( buf, txt );
  strcat( buf, "</TD><TD>\r" );
  strcat( buf, kolor );
  sprintf( txt, "<font color='BLUE'>E Czynna = %d,%03dkWh</font>", EnergiaCzynna / 1000, EnergiaCzynna % 1000 ); strcat( buf, txt );
  if ( ip[3] == 52 ) {
    sprintf( txt, "<font color='BLUE'></BR>ZE = %d,%03dkWh</B></font> ",  EnergiaCzynnaSyncZE / 1000, EnergiaCzynnaSyncZE % 1000 ); strcat( buf, txt );
  }
  sprintf( txt, "<BR>E Bierna = %d,%03dkVArh</TD>", EnergiaBierna / 1000, EnergiaBierna % 1000 ); strcat( buf, txt );
  strcat( buf, "</TD></tr></TABLE>\r" );


  strcat( buf, "<TABLE cellspacing='10' cellpadding='5'> <tr style='vertical-align: top; '><TD>\r" );
  //String str = NTP.getTimeDateString(); strcpy( txt, str.c_str() ); strcat( buf, txt );
  sprintf( txt, "%d-%d-%d %d:%d:%d", dtYYYY, dtMIES, dtDD, dtGG, dtMM, dtSS ); strcat( buf, txt );
  if ( NTP.isSummerTime() ) {
    strcpy( txt, "<BR>Czas letni. " ); ;
    strcat( buf, txt );
  } else {
    strcpy( txt, "<BR>Czas zimowy. " ); ;
    strcat( buf, txt );
  }
  strcat( buf, "</TD><TD>\r" );
  //Puste pole (kiedy LOOP=)
  strcat( buf, "</TD><TD>\r" );


  // todo: mozliwosc wpisania w formularzu "<iframe width = ......... i zapis do eeprom. Wtedy nie potrzeba if ( ip[3] == ....
  if ( ip[3] == 52 ) {
    // todo: Uzupełnić !!!/zmodyfikowac ponizsze linki !!!
    strcat( buf, "<A HREF='https://thingspeak.com/channels/xxxx' TARGET='_blank' >Rejestrator</A>\r" );
    if ( ! ee.fl_ThingOn ) strcat( buf, "<font color='RED'> (Off)</font>" );
    strcat( buf, "</TD><TD><input type='button' value='Reload Page' onClick='document.location.reload(true)'>\r" );
    strcat( buf, "</TD></tr></TABLE>\r" );
    strcat( buf, "<P><iframe width='450' height='260' style='border: 1px solid #cccccc;' src='https://thingspeak.com/channels/xxxxxxx/charts/2?bgcolor=%23ffffff&color=%23d62020&dynamic=true&results=60&title=Moc+G%C5%82%C3%B3wny&type=line'>< / iframe >" );
  }
  else if ( ip[3] == 53 ) {
    // todo: Uzupełnić !!!/zmodyfikowac ponizsze linki !!!
    strcat( buf, "<A HREF='https://thingspeak.com/channels/xxxx' TARGET='_blank' >Rejestrator</A>\r" );
    if ( ! ee.fl_ThingOn ) strcat( buf, "<font color='RED'> (Off)</font>" );
    strcat( buf, "</TD><TD><input type='button' value='Reload Page' onClick='document.location.reload(true)'>\r" );
    strcat( buf, "</TD></tr></TABLE>\r" );
    strcat( buf, "<P><iframe width='450' height='260' style='border: 1px solid #cccccc;' src='https://thingspeak.com/channels/xxxxxx/charts/2?bgcolor=%23ffffff&color=%23d62020&dynamic=true&results=60&type=line&update=15'>< / iframe > ");
  }
  else if ( ip[3] == 54 ) {
    // todo: Uzupełnić !!! jak maja byc wykresy
    //    strcat( buf, "<A HREF='https://thingspeak.com/channels/xxxxx' TARGET='_blank' >Rejestrator</A>\r" );
    //    if( ! ee.fl_ThingOn ) strcat( buf, "<font color='RED'> (Off)</font>" );
    strcat( buf, "</TD><TD><input type='button' value='Reload Page' onClick='document.location.reload(true)'>\r" );
    strcat( buf, "</TD></tr></TABLE>\r" );
    //    strcat( buf, "<P><iframe width='450' height='260' style='border: 1px solid #cccccc;' src='https://thingspeak.com/channels/xxxxxxx/charts/2?bgcolor=%23ffffff&color=%23d62020&dynamic=true&results=60&type=line&update=15'>< / iframe > ");
  }
  else {
    strcat( buf, "</TD><TD><input type='button' value='Reload Page' onClick='document.location.reload(true)'>\r" );
  }



  //strcat( buf, "<P><A HREF='/s'>Skanuj I2C</A>" );


  //  webServer.send( 200, "text / plain", buf );
  webServer.send( 200, "text/html; charset=iso-8859-2", buf );
  /*
    void  send (int code, const String &content_type, const String &content)
    void  sendHeader (const String &name, const String &value, bool first=false)
    void  sendContent (const String &content)
  */
}


//------------------------------------------------------------
void fwHandler() {
  char txt[200];//1111111111222222222233333333334444444444555555555566666666667777777777888888888899999999990000000000


  // todo: test:
  //Serial.print( "hostHeader():" ); Serial.println( webServer.hostHeader() ); // adres wpisany w przegladarce
  //Serial.print( "uri():" ); Serial.println( webServer.uri() );      // URL (bez argumentow GET)



  String heder = webServer.hostHeader();
  char tx[4];
  strncpy( tx, heder.c_str(), 3 ); // Pierwsze 3 znaki na liczbe
  uint8_t ip_clienta = atoi( tx );


  for (word h = 0; h < webServer.headers(); h++) {
    Serial.print( "\n\rhName=" );
    Serial.println( webServer.headerName( h ) );
    Serial.print( "header=" );
    Serial.print( webServer.header( h ) );
    Serial.print( "\n\r<<<" );
  }


  //  strcpy( buf, "<head> <title>Licznik ORNO</title> <meta http-equiv='refresh' content='5' /> </head>" );  // Firefox burzy sie na 'refresh'
  strcpy( buf, "<head> <title>Licznik ORNO</title> </head>" );

  if ( ornoOnLine ) {
    if ( typOrno == 514 ) {
      strcat( buf, "<H3>Licznik ORNO 514 " );
    }
    else {
      strcat( buf, "<H3>Licznik ORNO 504 " );
    }
  }
  else { // Licznik nieodpowiada
    strcat( buf, "<H3>Licznik ORNO <font color='RED'>xxx </font>" );
  }

  if ( ornoOnLine ) {
    if ( rdORNOfull >= LICZBA_PYTAN_ORNO ) {
      sprintf( txt, "<font color='GREEN'><B>RS485 ON-Line </B>Read record %d</font> (%d/%dms)", rdORNOfull, czasOdpowiedziOrno, czasTransmisjiOrno ); strcat( buf, txt );
    }
    else {
      sprintf( txt, "<font color='ORANGE'><B>RS485 ON-Line </B>Read record %d</font> (%d/%dms)", rdORNOfull, czasOdpowiedziOrno, czasTransmisjiOrno ); strcat( buf, txt );
    }
  }
  else {
    int tim = millis() - timeoutAskOrno; // czas przez jaki nieprzychodza odpowiedzi
    if ( tim < 0 ) tim = 0;
    sprintf( txt, "<font color='RED'> <B>RS485 OFF-Line </B> Time %d sekund </font>", tim / 1000 ); strcat( buf, txt );
  }
  strcat( buf, "</H3>\r" );


  sprintf( txt, "FW v1.0 %s %s", __DATE__, __TIME__ ); strcat( buf, txt );
  sprintf( txt, "<BR>SysTick: %d sekund", millis() / 1000 ); strcat( buf, txt );
  uint32_t tmax = TimLoopMax / 1000; // INFO: Na WWW czas jest wiekszy niz w serialmonitor bo dochodzi czas obslugi WWW
  sprintf( txt, "<BR>Loop=%dus, Max=%d.%03dsek", TimLoop, tmax / 1000, tmax % 1000 ); strcat( buf, txt );
  uint32_t t = ( millis() - timAktywnyTunel) / 100;
  sprintf( txt, "<BR>Tunel %d,%01dsek.", t / 10, t % 10 ); strcat( buf, txt );


  //  if ( webServer.arg(0) == "on" ) ee.fl_OrnoOn = true; else ee.fl_OrnoOn = false;
  //  if ( webServer.arg(1) == "on" ) ee.fl_ThingOn = true; else ee.fl_ThingOn = false;
  /*
    for (byte a = 0; a < webServer.args(); a++) {
    if ( webServer.argName(a) == "orno" ) {
      if ( webServer.arg(a) == "on" ) ee.fl_OrnoOn = true;
      else if ( webServer.arg(a) == "off" ) ee.fl_OrnoOn = false;
    }
    if ( webServer.argName(a) == "thing" ) {
      if ( webServer.arg(a) == "on" ) ee.fl_ThingOn = true;
      else if ( webServer.arg(a) == "off" ) ee.fl_ThingOn = false;
    }
    }
  */
  String flag = webServer.arg( "type" );
  if ( flag == "514" ) ee.typLicznika = 514;
  else if ( flag == "504" ) ee.typLicznika = 504;
  else if ( flag == "auto" ) ee.typLicznika = 0;

  webServer.arg( "thing" );
  if (  flag == "on" ) ee.fl_OrnoOn = true;
  else if ( flag == "off" ) ee.fl_OrnoOn = false;

  flag = webServer.arg( "thing" );
  if ( flag == "on" ) ee.fl_ThingOn = true;
  else if ( flag == "off" ) ee.fl_ThingOn = false;



  //todo: jesli parametr zmienil sie to zapis do eeprom
  eeWrite();


  /*
    //todo: test
    Serial.print( "*** args='" ); Serial.print( webServer.args() );
    Serial.print( "' arg='" ); Serial.print( webServer.arg(0) );
    Serial.print( "' argName='" ); Serial.print( webServer.argName(0) );
    Serial.print( "' arg='" ); Serial.print( webServer.arg(1) );
    Serial.print( "' argName='" ); Serial.print( webServer.argName(1) );
  */


  strcat( buf, "<P><P><form action='fw' method='get'>\r" );
  //----- Radio checkbox typ licznika
  strcat( buf, "ORNO <input type='radio' name='type' value='514'" );
  if ( ee.typLicznika == 514 ) strcat( buf, "checked" );   // domyslnie wlaczone
  strcat( buf, ">Orno-514\r" );
  strcat( buf, "<input type='radio' name='type' value='504'");
  if ( ee.typLicznika == 504 ) strcat( buf, "checked" );   // domyslnie wylaczone
  strcat( buf, ">Orno-504" );
  strcat( buf, "<input type='radio' name='type' value='auto'");
  if ( ! ee.typLicznika ) strcat( buf, "checked" );   // domyslnie wylaczone
  strcat( buf, ">Auto\r" );

  //----- Radio checkbox odpytywanie orno
  strcat( buf, "<BR>ORNO <input type='radio' name='orno' value='on'" );
  if ( ee.fl_OrnoOn ) strcat( buf, "checked" );   // domyslnie wlaczone
  strcat( buf, ">ON\r" );
  strcat( buf, "<input type='radio' name='orno' value='off'");
  if ( ! ee.fl_OrnoOn ) strcat( buf, "checked" );   // domyslnie wylaczone
  strcat( buf, ">Off\r" );
  //----- Radio checkbox Thing
  strcat( buf, "<BR>ThingSpeak <input type='radio' name='thing' value='on'" );
  if ( ee.fl_ThingOn ) strcat( buf, "checked" );   // domyslnie wlaczone
  strcat( buf, ">ON\r" );
  strcat( buf, "<input type='radio' name='thing' value='off'");
  if ( ! ee.fl_ThingOn ) strcat( buf, "checked" );   // domyslnie wylaczone
  strcat( buf, ">Off\r" );
  //----- Wyslij
  if ( ip[0] == ip_clienta ) strcat( buf, "<BR><input type='submit' value='Zapisz'>\r" );
  else strcat( buf, "<BR><input type='submit' value='Zapisz' disabled><font color='RED'> Zapis aktywny tylo sieci lokalnej</font>\r" );
  strcat( buf, "</form>\r" );


  strcat( buf, "<P><P><P><button onclick='goBack()'>Go Back</button> ");
  strcat( buf, " <input type='button' value='Reload Page' onClick='document.location.reload(true)'>\r" );
  strcat( buf, "<script> ");
  strcat( buf, "function goBack() { ");
  strcat( buf, "  window.history.back(); ");
  strcat( buf, "} ");
  strcat( buf, "</script> ");
  //strcat( buf, "<P><P><A HREF='/'>Wstecz</A>" );

  webServer.send( 200, "text/html; charset=iso-8859-2", buf );
}


//------------------------------------------------------------
void notFoundHandler()
{
  webServer.send( 404, "text/plain", "Strona nie istnieje." );
}
//w loop():
//  webServer.handleClient();
//w setup():
//  webServer.on( " / ", IndexHandler );    // tych deklaracji moze byc wiele,co by to nie znaczylo
//  webServer.onNotFound( notFoundHandler );
//  webServer.begin();


//------------------------------------------------------------
boolean syncEventTriggered = false; // True if a time even has been triggered
NTPSyncEvent_t ntpEvent; // Last triggered event
int8_t timeZone = 1;
int8_t minutesTimeZone = 0;
bool wifiFirstConnected = true; //false;


//------------------------------------------------------------
// Start NTP only after IP network is connected
void onSTAGotIP (WiFiEventStationModeGotIP ipInfo) {
#ifdef DEBUG_UART1
  Serial1.printf ( ANSI_PEN_MAGNETA"*** NTP Got IP: "ANSI_PEN_MAGNETA"%s\r\n"ANSI_PEN_WHITE, ipInfo.ip.toString ().c_str ());
  Serial1.printf ("Connected: %s\r\n", WiFi.status () == WL_CONNECTED ? "yes" : "no");
#endif

  wifiFirstConnected = true;
}


//------------------------------------------------------------
void onSTAConnected (WiFiEventStationModeConnected ipInfo) {
#ifdef DEBUG_UART1
  Serial1.printf ( ANSI_PEN_GREEN"*** NTP Connected to %s\r\n"ANSI_PEN_WHITE, ipInfo.ssid.c_str ());
#endif
}


//------------------------------------------------------------
// Manage network disconnection
void onSTADisconnected (WiFiEventStationModeDisconnected event_info) {
#ifdef DEBUG_UART1
  Serial1.printf (ANSI_PEN_RED"*** NTP Disconnected from SSID: %s\n"ANSI_PEN_WHITE, event_info.ssid.c_str ());
  Serial1.printf ("Reason: %d\n", event_info.reason);
#endif

  //NTP.stop(); // NTP sync can be disabled to avoid sync errors
}


//------------------------------------------------------------
void processSyncEvent(NTPSyncEvent_t ntpEvent) {
  if (ntpEvent) {
    printDebug( ANSI_PEN_RED"*** NTP Time Sync error: "ANSI_PEN_WHITE );
    if (ntpEvent == noResponse)
      printDebug( ANSI_PEN_RED"NTP server not reachable"ANSI_PEN_WHITE);
    else if (ntpEvent == invalidAddress)
      printDebug("Invalid NTP server address");
  } else {
    printDebug( ANSI_PEN_GREEN"*** NTP Got NTP time: "ANSI_PEN_CYAN );
#ifdef DEBUG_UART1
    Serial1.println ( NTP.getTimeDateString(NTP.getLastNTPSync() ) );  // todo:
#endif
    printDebug( ANSI_PEN_WHITE );
  }
}


//------------------------------------------------------------
unsigned int CRC16(unsigned char val[] , unsigned char len)
{
  unsigned int crc = 0xffff;
  unsigned char i, k;


  for (k = 0; k < len; k++)
  {
    crc = crc ^ val[k];
    i = 8;
    while (i)
    {
      if (crc & 1)
      {
        crc = crc >> 1;
        crc = crc ^ 0xA001;
      }
      else
      {
        crc = crc >> 1;
      }
      i--;
    }
  }

  return crc;
}
/*
  const byte auchCRCHi[256] = {
  0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81,
  0x40, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0,
  0x80, 0x41, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x00, 0xc1, 0x81, 0x40, 0x01,
  0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x01, 0xc0, 0x80, 0x41,
  0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x00, 0xc1, 0x81,
  0x40, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x01, 0xc0,
  0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x01,
  0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40,
  0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81,
  0x40, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0,
  0x80, 0x41, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x00, 0xc1, 0x81, 0x40, 0x01,
  0xc0, 0x80, 0x41, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41,
  0x00, 0xC1, 0x81, 0x40, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81,
  0x40, 0x01, 0xc0, 0x80, 0x41, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0,
  0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x01,
  0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81, 0x40, 0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41,
  0x00, 0xc1, 0x81, 0x40, 0x01, 0xc0, 0x80, 0x41, 0x01, 0xc0, 0x80, 0x41, 0x00, 0xc1, 0x81,
  0x40
  };

  const byte auchCRCLo [256] = {
  0x00, 0xc0, 0xc1, 0x01, 0xc3, 0x03, 0x02, 0xc2, 0xc6, 0x06,
  0x07, 0xc7, 0x05, 0xc5, 0xc4, 0x04, 0xcc, 0x0c, 0x0d, 0xcd,
  0x0f, 0xcf, 0xce, 0x0e, 0x0a, 0xca, 0xcb, 0x0b, 0xc9, 0x09,
  0x08, 0xc8, 0xd8, 0x18, 0x19, 0xd9, 0x1b, 0xdb, 0xda, 0x1a,
  0x1e, 0xde, 0xdf, 0x1f, 0xdd, 0x1d, 0x1c, 0xdc, 0x14, 0xd4,
  0xd5, 0x15, 0xd7, 0x17, 0x16, 0xd6, 0xd2, 0x12, 0x13, 0xd3,
  0x11, 0xd1, 0xd0, 0x10, 0xf0, 0x30, 0x31, 0xf1, 0x33, 0xf3,
  0xf2, 0x32, 0x36, 0xf6, 0xf7, 0x37, 0xf5, 0x35, 0x34, 0xf4,
  0x3c, 0xfc, 0xfd, 0x3d, 0xff, 0x3f, 0x3e, 0xfe, 0xfa, 0x3a,
  0x3b, 0xfb, 0x39, 0xf9, 0xf8, 0x38, 0x28, 0xe8, 0xe9, 0x29,
  0xeb, 0x2b, 0x2a, 0xea, 0xee, 0x2e, 0x2f, 0xef, 0x2d, 0xed,
  0xec, 0x2c, 0xe4, 0x24, 0x25, 0xe5, 0x27, 0xe7, 0xe6, 0x26,
  0x22, 0xe2, 0xe3, 0x23, 0xe1, 0x21, 0x20, 0xe0, 0xa0, 0x60,
  0x61, 0xa1, 0x63, 0xa3, 0xa2, 0x62, 0x66, 0xa6, 0xa7, 0x67,
  0xa5, 0x65, 0x64, 0xa4, 0x6c, 0xac, 0xad, 0x6d, 0xaf, 0x6f,
  0x6e, 0xae, 0xaa, 0x6a, 0x6b, 0xab, 0x69, 0xa9, 0xa8, 0x68,
  0x78, 0xb8, 0xb9, 0x79, 0xbb, 0x7b, 0x7a, 0xba, 0xbe, 0x7e,
  0x7f, 0xbf, 0x7d, 0xbd, 0xbc, 0x7c, 0xb4, 0x74, 0x75, 0xb5,
  0x77, 0xb7, 0xb6, 0x76, 0x72, 0xb2, 0xb3, 0x73, 0xb1, 0x71,
  0x70, 0xb0, 0x50, 0x90, 0x91, 0x51, 0x93, 0x53, 0x52, 0x92,
  0x96, 0x56, 0x57, 0x97, 0x55, 0x95, 0x94, 0x54, 0x9c, 0x5c,
  0x5d, 0x9d, 0x5f, 0x9f, 0x9e, 0x5e, 0x5a, 0x9a, 0x9b, 0x5b,
  0x99, 0x59, 0x58, 0x98, 0x88, 0x48, 0x49, 0x89, 0x4b, 0x8b,
  0x8a, 0x4a, 0x4e, 0x8e, 0x8f, 0x4f, 0x8d, 0x4d, 0x4c, 0x8c,
  0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42,
  0x43, 0x83, 0x41, 0x81, 0x80, 0x40
  };


  uint16_t CRC16(uint8_t *puchMsg, uint8_t usDataLen)
  {
  static unsigned char uIndex = 0;
  static unsigned char uchCRCHi;
  static unsigned char uchCRCLo;
  uchCRCHi = 0xff;
  uchCRCLo = 0xff;

  while (usDataLen --)
  {
    uIndex = uchCRCHi ^ *puchMsg++;
    uchCRCHi = uchCRCLo ^ auchCRCHi[uIndex];
    uchCRCLo = auchCRCLo[uIndex];
  }
  return (uchCRCHi << 8 | uchCRCLo);
  }
*/


//------------------------------------------------------------
void setUart() {
  if ( typOrno == 514 ) {
    Serial.begin(BAUD, FORMAT_UART_514);
  }
  else {
    Serial.begin(BAUD, FORMAT_UART_504);
  }

  Serial1.begin(BAUD_DEBUG);
#ifdef DEBUG_SOFT
  mySerial.begin(115200);
#endif
}


//------------------------------------------------------------
void ustalanieTypuLicznika() {
  uint32_t static timeout;



  // if ( ustalonyTypLicznika ) return;

  if ( ornoOnLine ) return;    // Jesli licznik odpowiada

  if ( millis() < timeout ) return; // Jesli nie minal czas na odpowiedzi licznika
  timeout = millis() + TIM_NEXT_TEST_TYPU;

  if ( ! ee.typLicznika ) {   // Jesli AUTO
    if ( typOrno == 504 ) {
      typOrno = 514;
    }
    else typOrno = 504;

    setUart();

    printDebug( "\n\r*** Testuje licznik typu " );
    if ( typOrno == 504 ) printDebug( "504 ***\n\r" );
    else printDebug( "514 ***\n\r" );
  }
  else if ( ee.typLicznika == 514 ) {
    typOrno = 514;
    setUart();
  }
  else if ( ee.typLicznika == 504 ) {
    typOrno = 504;
    setUart();
  }
}


//===========================================================
uint16_t lenBufSerTx;

void setup() {
  ESP.wdtEnable(1000);

  pinMode( LED_PIN_R , OUTPUT);
  pinMode( LED_PIN_Y , OUTPUT);
  pinMode( LED_PIN_G , OUTPUT);
  pinMode( LED_PIN_B , OUTPUT);
#if _WEMOS == 0
  pinMode( LED_PIN_SCK , OUTPUT);
  digitalWrite( LED_PIN_SCK, LOW);
#endif
  digitalWrite( LED_PIN_R, LOW);
  digitalWrite( LED_PIN_Y, LOW);
  digitalWrite( LED_PIN_G, HIGH);
  digitalWrite( LED_PIN_B, LOW);


  setUart();
  printDebug( ANSI_CLS""ANSI_PEN_YELLOW"***"ANSI_PEN_RED" Reset systemu"ANSI_PEN_YELLOW" ***\n\r\n\r"ANSI_PEN_WHITE );
  eeRead();


  WiFi.begin(WIFI_SSID, WIFI_PASS);
#ifndef DHCP
  WiFi.mode(WIFI_STA);
  WiFi.config(staticIP, gateway, subnet);
#endif
  pinMode(DIR485, OUTPUT);
  digitalWrite(DIR485, LOW);

  Find_WiFi();
  localServer.begin();
  localServer.setNoDelay(true);


  delay(100); // Czas na oproznienie bufora nadawczego UART
  lenBufSerTx = Serial.availableForWrite();
  {
    char txt[50];
    sprintf( txt, "\n\rBufor nadawczy UART %d bajtow", lenBufSerTx ); printDebug( txt );
  }

  webServer.on( "/", IndexHandler );
  webServer.on( "/fw", fwHandler );
  /*
    webServer.on("/", []() {
    if (!webServer.authenticate( "user", "1234" )) {    // cos nie dziala
      return webServer.requestAuthentication();
    }
    webServer.send(200, "text/plain", "Login ok");
    });
  */
  webServer.onNotFound( notFoundHandler );
  webServer.begin();


  Udp.begin(localUdpPort);
  Serial1.printf("\n\rNow listening at IP %s, UDP port %d\n", WiFi.localIP().toString().c_str(), localUdpPort );


  ThingSpeak.begin(client_thingspeak);


  static WiFiEventHandler e1, e2, e3;

  NTP.onNTPSyncEvent ([](NTPSyncEvent_t event) {
    ntpEvent = event;
    syncEventTriggered = true;
  });
  // Deprecated
  /*WiFi.onEvent([](WiFiEvent_t e) {
      Serial.printf("Event wifi -----> %d\n", e);
    });*/
  e1 = WiFi.onStationModeGotIP (onSTAGotIP);// As soon WiFi is connected, start NTP Client
  e2 = WiFi.onStationModeDisconnected (onSTADisconnected);
  e3 = WiFi.onStationModeConnected (onSTAConnected);



  CzasDoRstWifi = millis() + DEF_RESTART_WIFI;
  CzasDoResetu = millis() + 1 * 60 * 60 * 1000; // 24h   //CzasDoResetu = millis() + 24 * 60 * 60 * 1000; // 24h
  ESP.wdtEnable(100);


#define TIM_BLINK_RUN     500
  LedBlink( LED_B, TIM_BLINK_RUN );     //----- Miganie diody RUN -----//
  LedBlink( LED_SCK, TIM_BLINK_RUN );   //----- Miganie diody RUN -----//
  digitalWrite( LED_PIN_R, HIGH);
  digitalWrite( LED_PIN_Y, HIGH);
  digitalWrite( LED_PIN_G, HIGH);
}


//------------------------------------------------------------
void Find_WiFi() {
  printDebug( ANSI_PEN_YELLOW"\n\rRozlaczony, Lacze z sieca Wi-Fi '"ANSI_PEN_WHITE );
#ifdef DEBUG_UART1
  Serial1.print( WIFI_SSID ); // todo: printDebug
#endif
  printDebug("'...");


  while (WiFi.status() != WL_CONNECTED) {
    ESP.wdtFeed();
    delay(100);
    LedChg( LED_B );
    LedChg( LED_G );
    LedChg( LED_SCK );
    printDebug(".");
  }
  printDebug( ANSI_PEN_GREEN"\n\rPolaczony z siecia '"ANSI_PEN_WHITE );   //toido: przez printDebug
#ifdef DEBUG_UART1
  Serial1.print( WIFI_SSID );
  printDebug("' IP ");
  Serial1.print( WiFi.localIP() ); // todo:
#endif
  printDebug(". Tryb UART BRIDGE ");

  Serial.flush();


  String ips = WiFi.localIP().toString();
  char t[20];
  strncpy( t, ips.c_str(), 3 ); // Pierwsze 3 znaki na liczbe
  ip[0] = atoi( t );
  strncpy( t, ips.c_str(), 20 - 1 );  // String do tablicy
  strcpy( t, t + strlen(t) - 2 );     // Ostatnie dwa znaki na liczbe todo: użyć .substring(from, to)	https://www.arduino.cc/reference/en/language/variables/data-types/string/functions/substring/
  ip[3] = atoi( t );
  /*
    Serial.print( "\n\r***IP[0]=" );
    Serial.print( ip[0] );
    Serial.print( " [3]=" );
    Serial.print( ip[3] );
    Serial.print( t );

    if ( ips == "192.168.2.52" ) {
      ip[3] = 52;
    }
    else if ( ips == "192.168.2.53" ) {
      ip[3] = 53;
    }
    else if ( ips == "192.168.2.54" ) {
      ip[3] = 54;
    }
  */
}


//------------------------------------------------------------
void wyslij_na_RS485( uint8_t *sbuf, size_t len) {


#if defined( DEBUG_MODBUS )
  char txt[100];
  sprintf( txt, ANSI_PEN_MAGNETA"\n\r->RS485 tx %: "ANSI_PEN_WHITE, len ); printDebugModbus( txt );
  for ( byte x = 0; x < len; x++) {
    if ( x == 5 ) printDebug( ANSI_PEN_CYAN );
    else if ( x == len - 2 )  printDebug( ANSI_PEN_WHITE );
    sprintf( txt, "%02x ", sbuf[x] ); printDebugModbus( txt );
  }
  // printDebugModbus( "\n\r" );
#endif


  //----- Czekanie na zakonczenie poprzedniej transmisji
  while ( Serial.availableForWrite() != lenBufSerTx ) ; // Get the number of bytes (characters) available for writing in the serial buffer without blocking the write operation.
  delayMicroseconds( TIM_SEND_BYTE_UART ); // Konieczne, bo używając "Serial.availableForWrite()" stwierdzimy kiedy bufor jest pusty a nie kiedy znak wyslano z UART
#if defined( DEBUG ) || defined( DEBUG_UART0 ) || defined( DEBUG_UART1 )
  delay(2); //todo: to tylko aby lepuej bylo widac na analizatorze logicznym
#endif


  /*
    #ifdef DEBUG
    char txt[10];
    myserial.print( "->485: " );
    for (byte x = 0; x < len; x++) {
    sprintf( txt, "%0xd ", sbuf[x]); myserial.print( txt );
    }
    myserial.println();
    #endif
  */


  digitalWrite(DIR485, HIGH);
#ifdef DELAY_DIR
  delay(1);
#endif
  Serial.write(sbuf, len);
  //  delay( len * 1.2 );//mozna tez czekac liczba bajtow x 1.2ms, bo wyslanie 1 bajtu przy 9600 8E1 trwa ok 0,0011458ms: 1/(9600/11)
  while ( Serial.availableForWrite() != lenBufSerTx ) ; // Get the number of bytes (characters) available for writing in the serial buffer without blocking the write operation.
  //extern inline size_t uart_tx_fifo_available(const int uart_nr);
  //while ( uart_tx_fifo_available( UART0 ) ) ;
  //while ( (USS0 >> USTXC) & 0xff ) ;
  delayMicroseconds( TIM_SEND_BYTE_UART ); // Konieczne, bo używając "Serial.availableForWrite()" stwierdzimy kiedy bufor jest pusty a nie kiedy znak wyslano z UART
#ifdef DELAY_DIR
  delay(1);
#endif
  digitalWrite(DIR485, LOW);
  //Serial.println();

  /*
    void uart_wait_tx_empty(uart_t* uart) {
    if(uart == NULL || !uart->tx_enabled)
        return;

    while(uart_tx_fifo_available(uart->uart_nr) > 0)
        delay(0);

    }
    exp:
    uart_wait_tx_empty( USS1 )


    inline size_t uart_tx_fifo_available(const int uart_nr) {
    return (USS(uart_nr) >> USTXC) & 0xff;
    }
    exp: uart_tx_fifo_available( 0 )
    uart_tx_fifo_available( UART0 )
    uart_tx_fifo_available( UART1 )


    size_t uart_tx_free(uart_t* uart) {
    if(uart == NULL || !uart->tx_enabled)
        return 0;

    return UART_TX_FIFO_SIZE - uart_tx_fifo_available(uart->uart_nr);
    }
    exp: uart_tx_free( USS0 );


    https://github.com/esp8266/Arduino/blob/master/cores/esp8266/uart.h
    https://github.com/esp8266/Arduino/blob/master/cores/esp8266/uart.cpp
  */
}


//------------------------------------------------------------
void printDebug( char * txt ) {
#ifdef DEBUG_SOFT
  mySerial.print( txt );
#endif
#ifdef DEBUG_UART0
  Serial.print( txt );
#endif
#ifdef DEBUG_UART1
  Serial1.print( txt );
#endif
}


void printDebugModbus( char * txt ) {
#ifdef DEBUG_MODBUS
  printDebug( txt );
#endif
}


//------------------------------------------------------------
int8_t static fl_PytanieOrno;
unsigned long static timeoutOdpytanie;
//------------------------------------------------------------
//----- Cykliczne odpytywanie licznika -----//
//------------------------------------------------------------
void Zapytania_Do_Orno() {


  if ( ! ee.fl_OrnoOn ) return;


  // INFO: 514 bez względu na to o ile rejestów pytamy odpowie jednym
  const byte zapytanie_514[][8] =
  {
    { 0x00, 0x03, 0x01, 0x31, 0x00, 0x01, 0xD5, 0xE8 }, // Pytanie o napiecie
    { 0x00, 0x03, 0x01, 0x39, 0x00, 0x02, 0x14, 0x2B }, // Pytanie o prad
    { 0x00, 0x03, 0x01, 0x40, 0x00, 0x02, 0xC5, 0xF2 }, // Pytanie o moc czynna
    { 0x00, 0x03, 0x01, 0x48, 0x00, 0x02, 0x44, 0x30 }, // Pytanie o moc bierna
    { 0x00, 0x03, 0x01, 0x58, 0x00, 0x01, 0x05, 0xF4 }, // Pytanie o PF
    { 0x00, 0x03, 0xA0, 0x00, 0x00, 0x0A, 0xE6, 0x1C }, // Pytanie o zuzyta energie czynna
    { 0x00, 0x03, 0xA0, 0x1E, 0x00, 0x0A, 0x86, 0x1A }, // Pytanie o zuzyta energie bierna
    { 0x00, 0x03, 0x01, 0x50, 0x00, 0x02, 0xC4, 0x37 }, // Pytanie o moc pozorna
    { 0x00, 0x03, 0x01, 0x30, 0x00, 0x01, 0x84, 0x28 }, // Pytanie o czestotliwosc
    { 0xFF }
    //todo: mozliwosc modyfikacji ID oraz wyliczanie CRC zapytan
  };

  // INFO: 504 można pytac o dowolną liczbę rejestrów
  const byte zapytanie_504[][8] =
  {
    {
      0x00, 0x03, //00 03   ID, Function READ
      0x00, 0x00, //00 00   adr rej H, L
      0x00, 0x0a, //00 10   liczba rej do odczytu H, L
      0x45, 0xd7  //45 d7   CRC L, H
    },
    { 0xFF }
  };


  if ( millis() >= timeoutOdpytanie ) {
    timeoutOdpytanie = millis() + CO_ILE_PYTAC_ORNO;
    timeoutBusyOrno = millis() + DEF_BUSY_ACK_ORNO;    // Blokada zapytan przez Wi-Fi
    timOdpowiedziOrno = millis();

    fl_PytanieOrno = true;

    ++nrPytaniaOrno;
    if ( (zapytanie_514[nrPytaniaOrno][0] != 0xFF && typOrno == 514) ||
         (zapytanie_504[nrPytaniaOrno][0] != 0xFF && typOrno == 504) ) {
      //  wyslij_na_RS485( (uint8_t*)zapytanie[nrPytaniaOrno], 8 );

      uint8_t buf[8];
      if ( typOrno == 514 ) {
        memcpy( buf, (uint8_t*)zapytanie_514[nrPytaniaOrno], 6 );
      }
      else {
        memcpy( buf, (uint8_t*)zapytanie_504[nrPytaniaOrno], 6 );
      }

      uint16_t crc = CRC16( buf, 6 );
      buf[6] = crc;
      buf[7] = crc >> 8;
      wyslij_na_RS485( buf, 8 );

      // char txt[50]; sprintf( txt, "\n\r*** crc zapyrania %x", crc ); printDebug( txt );
    }
    else {
      nrPytaniaOrno = -1;
      timeoutOdpytanie = millis() + PAZUZA_ZAPYTAN_ORNO;

      if ( fl_WriteRTC && ee.fl_OrnoOn ) {
        fl_WriteRTC = false;

        // Zapis zegara
        //       ID CMD  AdrHL   NewAdr  Len  RR MM DD gg mm ss ?? ??
        //Write: 00 10 / 81 20 / 00 04 / 08 / 13 0A 1A 0C 1E 35 06 00 / E7 21
        //Read:  02 10 / 81 20 / 00 04 / E8 0F
        //
        //12:50:16:707  Write: 00 10 81 20 00 04 08 13 0A 1A 0C 32 0F 06 00 CF BC
        //12:50:17:108  Read:  02 10 81 20 00 04 E8 0F


        // Odczyt zegara
        //Write: 00 03 / 81 20 / 00 04 / 6C 2E
        //       ID CMD  Len  RR MM DD gg mm ss ?? ??
        //Read:  02 03 / 08 / 13 0A 1A 0C 1E 35 06 00 / 76 37

        byte dane[17] = { 0x00, 0x10, 0x81, 0x20, 0x00, 0x04, 0x08 }; // Stale elemety naglowka
        //todo: test:
        //dtYYYY = 2073; dtMIES = 05; dtDD = 18; dtGG = 15; dtMM = 20; dtSS = 30; //todo: test:
        //dtYYYY = 0x13; dtMIES = 0x0A; dtDD = 0x1A; dtGG = 0x0C; dtMM = 0x1E; dtSS = 0x35; //todo: test: powinno dać CRC E7 21

        dane[7] = dtYYYY;
        dane[8] = dtMIES;
        dane[9] = dtDD;
        dane[10] = dtGG;
        dane[11] = dtMM;
        dane[12] = dtSS;
        //
        dane[13] = 0x06;
        dane[14] = 0x00;
        uint16_t crc = CRC16( dane, 15 );
        dane[15] = crc;
        dane[16] = crc >> 8;

        //INFO: w ORNO-514 RTC to pic na wode (nie liczny czasu) ale zapisy cos nie tak. ORNO nie odpowiada choc wysyła ramke taka sama jak program testowy 9crc sie zgadza)

        char txt[50];
        printDebug( ANSI_PEN_YELLOW"\n\rZapis RTC ORNO: "ANSI_PEN_WHITE );
        for ( byte x = 0; x < 17; x++) {
          sprintf( txt, "%02x ", dane[x] );
          printDebug( txt );
        }
        sprintf( txt, "[%d-%d-%d %d:%d:%d]\n\r", dtYYYY, dtMIES, dtDD, dtGG, dtMM, dtSS ); printDebug( txt );

        wyslij_na_RS485( dane, 17 );
      }
    }
    /*
      //test:
      uint16_t c = CRC16( (uint8_t*)zapytanie[pytanie], 6 );
      uint16_t crc = zapytanie[pytanie][6] | zapytanie[pytanie][7] << 8;
      char txt[50];
      sprintf( txt, "\n\rCRC wyliczone %x otrzymane %x", c, crc ); printDebug( txt );
    */
  }
}


//------------------------------------------------------------
void WiFi_do_Uart() {
  //----- WiFi->UART -----//
  /*
    if (localClient && localClient.connected()) {
      if (localClient.available()) {
        size_t len = localClient.available();
        uint8_t sbuf[len];
        localClient.readBytes(sbuf, len);
        digitalWrite(DIR485, HIGH);
        delay(2);
        Serial.write(sbuf, len);
        delay(15);  // Niestety trzeba dobrac doswiadczalnie bo zalezy od dlugosci ramki
        //mozna tez czekac liczba bajtow x 1.2ms, bo wyslanie 1 bajtu przy 9600 8E1 trwa ok 0,0011458ms: 1/(9600/11)
        digitalWrite(DIR485, LOW);
      }
    }
  */
  if (localClient && localClient.connected() && millis() > timeoutBusyOrno ) {
    if (localClient.available()) {
      timeoutOdpytanie = millis() + PAZUZA_ZAPYTAN_ORNO;


      CzasDoTHINGSPEAK = millis() + Co_ILE_NA_THINGSPEAK;    // i wysylke
      CzasDoURL = millis() + Co_ILE_NA_URL;
      timAktywnyTunel = millis();


      size_t len = localClient.available();
      uint8_t sbuf[len];
      localClient.readBytes(sbuf, len);
      printDebug( ANSI_PEN_MAGNETA"\n\r*** Przeslano Wi-Fi->UART"ANSI_PEN_WHITE );
      wyslij_na_RS485(sbuf, len);

      //todo: wyswietlic wyslana ramke 9z ograniczniem do np 20 bajtow)
    }
  }
}


//------------------------------------------------------------
uint32_t stModbus;
//------------------------------------------------------------
void Uart_do_Wifi() {
  /*
    if (Serial.available()) {
      delay(20); // Czekamy az wiecej znakow bedzie w buforze (przy 9600 ok 10)

      size_t len = Serial.available();
      uint8_t sbuf[len];
      Serial.readBytes(sbuf, len);
      if (localClient && localClient.connected()) {
        localClient.write(sbuf, len);
      }
    }
  */
  uint32_t static timeoutWr, timCzasRd;
  size_t static prevLen;
  if ( prevLen != Serial.available() ) {    // jesli zmienil sie rozmiar bufora
    prevLen = Serial.available();
    if ( prevLen ) {                        // i jest rozny od 0
      timeoutWr = millis() + 5; // Przychodzacy znak ustawia timeout
      if ( ! timCzasRd ) timCzasRd = millis();
    }
  }


  if ( millis() >= timeoutWr ) { // Gdy timeout minie
    timeoutWr = 0xFF000000;   // Zatrymujemy liczenie

    size_t len = Serial.available();
    uint8_t sbuf[len];
    Serial.readBytes(sbuf, len);


    char txt[100];
#if defined( DEBUG_MODBUS )
    sprintf( txt, ANSI_PEN_CYAN"\n\r<-RS485 %drx (%d/%dms): "ANSI_PEN_WHITE, len, czasOdpowiedziOrno, czasTransmisjiOrno ); printDebugModbus( txt );
    for ( byte x = 0; x < len; x++) {
      if ( x == 3 ) printDebug( ANSI_PEN_MAGNETA );
      else if ( x == len - 2 )  printDebug( ANSI_PEN_WHITE );
      sprintf( txt, "%02x ", sbuf[x] ); printDebugModbus( txt );
    }
    //printDebugModbus( "\n\r" );
#endif


    //todo: funkcja
    //   if ( ! fl_PytanieOrno )
    { // Zapytanie z Wi-Fi
      printDebugModbus( ANSI_PEN_CYAN"\n\r*** UART->Wi-Fi"ANSI_PEN_WHITE );
      if (localClient && localClient.connected()) {
        printDebugModbus( " SEND..." );
        localClient.write(sbuf, len);
      }
    }
    if ( fl_PytanieOrno ) { // Jesli zapytanie lokalne (przez ESP)
      if ( len < 4 ) {
        printDebug( ANSI_PEN_RED"\n\rERROR: Odrzucono ze wzgledu na dlugosc"ANSI_PEN_WHITE );
        return;
      }

      fl_PytanieOrno = false;
      timeoutBusyOrno = 0;  // Zezwolenie na pytanie z WiFi
      czasOdpowiedziOrno = millis() - timOdpowiedziOrno;
      czasTransmisjiOrno = millis() - timCzasRd;
      timCzasRd = 0;
      if ( ! ustalonyTypLicznika ) {
        printDebug( ANSI_PEN_GREEN"\n\r*** Ustalono typ licznika ORNO "ANSI_PEN_WHITE );
        if ( typOrno == 514 ) printDebug( "514 ***\n\r" );
        else printDebug( "504 ***\n\r" );
      }
      ustalonyTypLicznika = true;

      uint16_t crcRX = sbuf[len - 2] | sbuf[len - 1] << 8;
      uint16_t crcCalculate = CRC16( sbuf, len - 2 );
      if ( crcRX != crcCalculate ) {
        if ( rdORNOfull ) rdORNOfull--; // licznik kompletu danych
        sprintf( txt, ANSI_PEN_RED"\n\rCRC Error! Wyliczone %x otrzymane %x"ANSI_PEN_WHITE, crcCalculate, crcRX ); printDebug( txt );
        LedFlash( LED_R, 500 );
      }
      else {
        if ( rdORNOfull < LICZBA_PYTAN_ORNO * 2 ) rdORNOfull++;
        timeoutAskOrno = millis() + TIM_OFLINE_ORNO;
        printDebugModbus( ANSI_PEN_GREEN"\n\rCRC OK"ANSI_PEN_WHITE );
        LedFlash( LED_Y, 50 );
        /*
          //todo: test:
            fl_bzdura = len;
            if ( fl_bzdura > LEN_ODP_ORNO ) fl_bzdura = LEN_ODP_ORNO;
            memcpy( BufOdpOrno, sbuf, len );    // Kopia odebranej ramki
        */

        if ( sbuf[1] != 3 ) {
          printDebug( ANSI_PEN_RED"\n\rOdrzucono ze wzgledu na kod funkcji."ANSI_PEN_WHITE );
          return;
        }
        if ( typOrno == 514 ) {
          switch ( nrPytaniaOrno ) {
            case 0:   // Pytanie o napiecie
              Napiecie = sbuf[3] << 8 | sbuf[4];
              sprintf( txt, "\n\rNapiecie=%d,%02d ", Napiecie / 100, Napiecie % 100  ); printDebugModbus( txt );
              break;
            case 1:   // Pytanie o prad
              Prad = sbuf[3] << 24 | sbuf[4] << 16 | sbuf[5] << 8 | sbuf[6];
              sprintf( txt, "Prad=%d,%03d ", Prad / 1000, Prad % 1000 ); printDebugModbus( txt );
              break;
            case 2:   // Pytanie o moc czynna
              MocCzynna = sbuf[3] << 24 | sbuf[4] << 16 | sbuf[5] << 8 | sbuf[6];
              sprintf( txt, "MocCzynna=%d,%03d ", MocCzynna / 1000, MocCzynna % 1000 ); printDebugModbus( txt );
              if ( MocCzynna > MAX_MOC_CZYNNA ) printDebugModbus( "\n\r********* Bzdurna moc czynna !!!!!!!!!\n\r" );
#ifndef MODBUS_HEX_ALL
              if ( MocCzynna > MAX_MOC_CZYNNA )
#endif
              {
                fl_bzdura = len;
                if ( fl_bzdura > LEN_ODP_ORNO ) fl_bzdura = LEN_ODP_ORNO;
                memcpy( BufOdpOrno, sbuf, len );    // Kopia odebranej ramki

                stModbus = MocCzynna;
              }
              break;
            case 3:   // Pytanie o moc bierna
              MocBierna = sbuf[3] << 24 | sbuf[4] << 16 | sbuf[5] << 8 | sbuf[6];
              sprintf( txt, "MocBierna=%d,%03d ", MocBierna / 1000, MocBierna % 1000 ); printDebugModbus( txt );
              break;
            case 4:   // Pytanie o PF
              WspolczynnikMocy = sbuf[3] << 8 | sbuf[4];
              sprintf( txt, "WspolczynnikMocy=%d,%03d ", WspolczynnikMocy / 1000, WspolczynnikMocy % 1000  ); printDebugModbus( txt );
              break;
            case 5:   // Pytanie o zuzyta energie czynna
              EnergiaCzynna = sbuf[3] << 24 | sbuf[4] << 16 | sbuf[5] << 8 | sbuf[6]; // Total, kolejne UINT32 to taryfy T1, T2, T3 i T4
              sprintf( txt, "EnergiaCzynnaa=%d,%03d ", EnergiaCzynna / 1000, EnergiaCzynna % 1000 ); printDebugModbus( txt );
              break;
            case 6:   // Pytanie o zuzyta energie bierna
              EnergiaBierna = sbuf[3] << 24 | sbuf[4] << 16 | sbuf[5] << 8 | sbuf[6]; // Total, kolejne UINT32 to taryfy T1, T2, T3 i T4
              sprintf( txt, "EnergiaBierna=%d,%03d ", EnergiaBierna / 1000, EnergiaBierna % 1000 ); printDebugModbus( txt );
              break;
            case 7:   // Pytanie o moc pozorna
              MocPozorna = sbuf[3] << 24 | sbuf[4] << 16 | sbuf[5] << 8 | sbuf[6];
              sprintf( txt, "MocPozorna=%d,%03d ", MocPozorna / 1000, MocPozorna % 1000 ); printDebugModbus( txt );
              break;
            case 8:   // Pytanie o czestotliwosc
              Czestotliwosc = sbuf[3] << 8 | sbuf[4];
              sprintf( txt, "Czestotliwosc=%d,%02d ", Czestotliwosc / 100, Czestotliwosc % 100 ); printDebugModbus( txt );
              break;
          }
        }
        else {
          //0 Napięcie (0,1V),
          //1 Natężenie (0,1A),
          //2 Częstotliwość (0,1Hz),
          //3 Moc czynna (1W),
          //4 Moc bierna (1var),
          //5 Moc pozorna (1VA),
          //6 Współczynnik mocy (1000),
          //7 i 8 Energia czynna (1Wh), Decimal Long - little endian
          //9 i A Energia bierna (1varh), Decimal Long - little endian

          // Rejestr 0 (buf = 0*2+3=3)
          Napiecie = sbuf[3] << 8 | sbuf[4]; Napiecie *= 10;
          sprintf( txt, "\n\rNapiecie=%d,%02d ", Napiecie / 100, Napiecie % 100  ); printDebugModbus( txt );
          // Rejestr 1 (buf = 1*2+3=5)
          Prad = sbuf[5] << 8 | sbuf[6]; Prad *= 100;
          sprintf( txt, "Prad=%d,%03d ", Prad / 1000, Prad % 1000 ); printDebugModbus( txt );
          Czestotliwosc = sbuf[7] << 8 | sbuf[8]; Czestotliwosc *= 10;
          sprintf( txt, "Czestotliwosc=%d,%02d ", Czestotliwosc / 100, Czestotliwosc % 100 ); printDebugModbus( txt );
          MocCzynna = sbuf[9] << 8 | sbuf[10];
          sprintf( txt, "MocCzynna=%d,%03d ", MocCzynna / 1000, MocCzynna % 1000 ); printDebugModbus( txt );
          MocBierna = sbuf[11] << 8 | sbuf[12];
          sprintf( txt, "MocBierna=%d,%03d ", MocBierna / 1000, MocBierna % 1000 ); printDebugModbus( txt );
          MocPozorna = sbuf[13] << 8 | sbuf[14];
          sprintf( txt, "MocPozorna=%d,%03d ", MocPozorna / 1000, MocPozorna % 1000 ); printDebugModbus( txt );
          // Rejestr 6 (buf = 6*2+3=15)
          WspolczynnikMocy = sbuf[15] << 8 | sbuf[16];
          sprintf( txt, "WspolczynnikMocy=%d,%03d ", WspolczynnikMocy / 1000, WspolczynnikMocy % 1000  ); printDebugModbus( txt );
          // Rejestr 7+8 (buf = 7*2+3=17)
          EnergiaCzynna = sbuf[17] << 24 | sbuf[18] << 16 | sbuf[19] << 8 | sbuf[20];
          sprintf( txt, "EnergiaCzynnaa=%d,%03d ", EnergiaCzynna / 1000, EnergiaCzynna % 1000 ); printDebugModbus( txt );
          // Rejestr 9+10 (buf = 9*2+3=21)
          EnergiaBierna = sbuf[21] << 24 | sbuf[22] << 16 | sbuf[23] << 8 | sbuf[24];
          sprintf( txt, "EnergiaBierna=%d,%03d ", EnergiaBierna / 1000, EnergiaBierna % 1000 ); printDebugModbus( txt );
          // SN - Rejestr 11+12 (buf = 11*2+3=25)
          // BAUD RATE - Rejestr 14 (buf = 14*2+3=31)
          // ID - Rejestr 15 (buf = 15*2+3=33)

          if ( rdORNOfull < LICZBA_PYTAN_ORNO ) rdORNOfull = LICZBA_PYTAN_ORNO;

          if ( MocCzynna > MAX_MOC_CZYNNA ) printDebugModbus( ANSI_PEN_RED"\n\r********* Bzdurna moc czynna !!!!!!!!!"ANSI_PEN_WHITE );
#ifndef MODBUS_HEX_ALL
          if ( MocCzynna > MAX_MOC_CZYNNA )
#endif
          {
            fl_bzdura = len;
            if ( fl_bzdura > LEN_ODP_ORNO ) fl_bzdura = LEN_ODP_ORNO;
            memcpy( BufOdpOrno, sbuf, len );    // Kopia odebranej ramki
          }
        }
      }
    }
  }
}


//------------------------------------------------------------
static int i_ntp = 0;
static int last_ntp = 0;
//------------------------------------------------------------
void obsluga_ntp() {

  if (wifiFirstConnected) {
    wifiFirstConnected = false;
    //     NTP.begin ("pool.ntp.org", timeZone, true, minutesTimeZone);
    NTP.begin ("ntp.itl.waw.pl", timeZone, true, minutesTimeZone);
    NTP.setInterval(CO_ILE_NTP);
    printDebug( ANSI_PEN_GREEN"*** NTP start "ANSI_PEN_WHITE );
  }
  if (syncEventTriggered) {
    processSyncEvent(ntpEvent);
    syncEventTriggered = false;
    printDebug( ANSI_PEN_MAGNETA"*** NTP SYNC "ANSI_PEN_WHITE );

    //----- Rozlozenie datay i czasu
    char txt[50];
    String str = NTP.getTimeDateString(); strcpy( txt, str.c_str() );
    // 0000000000111111111
    // 0123456789012345678
    // 10:11:07 26/10/2019
    //    sscanf( txt, "%d02:%d02:%d02 %d02/%d02/%d04", &dtGG, &dtMm, &dtSS, &dtDD, &dtMIES, &dtYYYY );
    //INFI: sscanf wywala program i to dziwnie. jak zmienne sa globalne zawsze problem. jak lokalne ok z czasem sscanf daty wysypuje
    //   sscanf( txt, "%d02", &dtGG );
    dtGG = (txt[0] - '0') * 10;
    dtGG += (txt[1] - '0');

    //   sscanf( txt + 3, "%d02", &dtMM );
    dtMM = (txt[3] - '0') * 10;
    dtMM += (txt[4] - '0');

    //   sscanf( txt + 6, "%d02", &dtSS );
    dtSS = (txt[6] - '0') * 10;
    dtSS += (txt[7] - '0');

    //   sscanf( txt + 6, "%d02", &dtDD );
    dtDD = (txt[9] - '0') * 10;
    dtDD += (txt[10] - '0');

    //   sscanf( txt + 12, "%d02", &dtMIES );
    dtMIES = (txt[12] - '0') * 10;
    dtMIES += (txt[13] - '0');

    //   sscanf( txt + 15, "%d02", &dtYYYY );
    dtYYYY = (txt[15] - '0') * 1000;
    dtYYYY += (txt[16] - '0') * 100;
    dtYYYY += (txt[17] - '0') * 10;
    dtYYYY += (txt[18] - '0');

    fl_WriteRTC = true; // zapis RTC do ORNO
    sprintf( txt, " %d-%d-%d% d:%d:%d\n\r", dtYYYY, dtMIES, dtDD, dtGG, dtMM, dtSS ); printDebug( txt );
  }


  //todo: zrobic funkcje
  if ((millis () - last_ntp) > CO_ILE_PRINT_CZAS && (WiFi.status() == WL_CONNECTED) ) {
    char txt[50];
    last_ntp = millis();
    printDebug("\n\r*** NTP "); // Serial.print(i_ntp); printDebug("  ");
    strcpy( txt, NTP.getTimeDateString().c_str() ); printDebug(txt);  printDebug(" ");
    if ( NTP.isSummerTime() ) printDebug( "Czas letni. " ); else printDebug( "Czas zimowy. " );
    printDebug( "WiFi is " );
    if ( WiFi.isConnected() ) printDebug( "connected" ); else printDebug( "not connected" );
    printDebug("\n\rUptime: ");
    strcpy( txt, NTP.getUptimeString().c_str() ); printDebug(txt);  printDebug(" since ");
    strcpy( txt, NTP.getTimeDateString( NTP.getFirstSync()).c_str() ); printDebug(txt);
    printDebug( "\n\r" );

    i_ntp++;
  }
}


//------------------------------------------------------------
uint32_t timWwwStat, timWwwEnd;
//------------------------------------------------------------
void obsluga_www() {
  webServer.handleClient();       //----- serwer HTTP -----//


  if (WiFi.status() == WL_CONNECTED)  {

    if ( millis() > CzasDoURL ) {
      CzasDoURL = millis() + Co_ILE_NA_URL + random( 0, 500 );

      //----- WWW (RPi)
      byte static cnt;
      if ( ++cnt >= Co_ILE_NA_URL_LOCAL_HOST ) cnt = 0;
      for (byte www = 0; www < LICZBA_HOSTOW; www++) {
        WiFiClient client;
        const int httpPort = 80;
        const char* host;

        if ( www == 0 ) host = DATA_HOST_REMOTE_1;
        else if ( www == 1 ) host = DATA_HOST_REMOTE_2;
        else if ( www == 2 ) host = DATA_HOST_LOCAL_2;
        else host = DATA_HOST_LOCAL_1;
        if ( host == "" ) { // Jesli nazwa hosta istnieje
          printDebug( ANSI_PEN_YELLOW"\n\rPomijam wylaczony host"ANSI_PEN_WHITE );
        }
        else {
          if (!client.connect(host, httpPort)) {
            printDebug( ANSI_PEN_RED"\n\rERROR: connection failed"ANSI_PEN_WHITE );
          }
          else {
            String url = LOGGER_URL;
            char txt[1000];
            if ( ! ornoOnLine ) { // Jesli off-line
              url += "moc='off-line";    // Gdy nie ma komunikacji z licznikiem
              url += "&pf='off-line";
            }
            else {
              url += "moc=";
              sprintf( txt, "%d,%03d", MocCzynna / 1000, MocCzynna % 1000 );
              url += txt;

              url += "&pf=";
              sprintf( txt, "%d,%03d", WspolczynnikMocy / 1000, WspolczynnikMocy % 1000 );
              url += txt;

              url += "&var=";
              sprintf( txt, "%d,%03d", MocBierna / 1000, MocBierna % 1000 );
              url += txt;

              url += "&VA=";
              sprintf( txt, "%d,%03d", MocPozorna / 1000, MocPozorna % 1000 );
              url += txt;

              url += "&I=";
              sprintf( txt, "%d,%03d", Prad / 1000, Prad % 1000  );
              url += txt;

              url += "&U=";
              sprintf( txt, "%d,%02d", Napiecie / 100, Napiecie % 100  );
              url += txt;

              url += "&f=";
              sprintf( txt, "%d,%02d", Czestotliwosc / 100, Czestotliwosc % 100  );
              url += txt;

              url += "&EP=";
              sprintf( txt, "%d,%03d", EnergiaCzynna / 1000, EnergiaCzynna % 1000 );
              url += txt;

              url += "&Evar=";
              sprintf( txt, "%d,%03d", EnergiaBierna / 1000, EnergiaBierna % 1000 );
              url += txt;

              if ( fl_bzdura ) { // Nienormalne ramki
                url += "&modbus=";
                for ( byte x = 0; x < fl_bzdura; x++) {
                  sprintf( txt, "%02x_", BufOdpOrno[x]  );
                  url += txt;
                }
                url += "&st=";
                if ( rdORNOfull < LICZBA_PYTAN_ORNO ) strcpy( txt, "no-complit" );  // jeśli dane niekompletne
                else sprintf( txt, "%d", stModbus  );
                url += txt;
                if ( www == LICZBA_HOSTOW - 1 ) fl_bzdura = false;  // Flage kasujemy gdy wysylka na ostatni host
              }
            }
            if ( ip[3] == 52 ) url += "&id=glowny"; //sprintf( txt, "%d", ip[3] ); url += "&id=";
            else if ( ip[3] == 53 ) url += "&id=warsztat";
            else if ( ip[3] == 54 ) url += "&id=przenosny";
            else {
              url += "&id=nowy";
              sprintf( txt, " %d", ip[3] ); url += txt;
            }

            uint32_t tim = timWwwStat = micros();
            timWwwEnd = 0;
            if ( www == 0 || www == 1 || ( www >= 2 && !cnt) ) { // na zdalny (www==0 lub 1) zawsze, lokalny (www<>0 i 1) tylko gdy cnt==0
#ifdef DEBUG_URL
              if ( www >= 2 ) printDebug( "\n\rSend >>> Local <<< host '" );
              else printDebug( "\n\rSend Remote host '" );
              printDebug( (char*)host );
              strcpy( txt, url.c_str() ); printDebug( txt );
              sprintf( txt, " [cnt=%d] ", cnt ); printDebug(txt);
              printDebug( "'" );
#endif
              client.print( String("GET ") + url + " HTTP/1.1\r\n" + "Host: " + host + "\r\n" + "Connection: close\r\n\r\n" );
#ifdef DEBUG_URL
              sprintf( txt, "\n\r Send GET %d.%02dms ", (micros() - tim) / 1000, (micros() - tim) % 1000 ); printDebug( txt ); //Czas na jaki angarzowany jest uC
#endif
#ifdef REPLY_WWW
              //----- Odpowiedz z WWW
              uint32_t timeout = millis() + OVERTIME_REPLY_WWW;
              while ( client.connected() || client.available() ) {
                if ( millis() >= timeout ) break;
                if ( client.available() ) {
                  if ( ! timWwwEnd ) timWwwEnd = micros();
                  String line = client.readStringUntil('\n');
#if defined( DEBUG_PRINT_REP_WWW ) && defined( DEBUG_UART1 )
                  printDebug( ANSI_PEN_CYAN"\n\rOdpowiedz ze strony \n\r"ANSI_PEN_YELLOW );
                  Serial1.println(line); //todo: printDebug
                  printDebug( ANSI_PEN_WHITE"\n\r" );
#endif
                }
              }
#ifdef DEBUG_URL
              sprintf( txt, "\n\r Read HTML %d.%02dms", (timWwwEnd - timWwwStat) / 1000, (timWwwEnd - timWwwStat) % 1000 ); printDebug( txt ); // Czas odpowiedzi z WWW
#endif
#endif
            }
          }
        }
      }
    }
  } // END if ( WiFi.status() == WL_CONNECTED )


  /*
    //todo: problem bardziej zlozony. Zapytania get trzeba wysylac pojedynczo a nie "hurtem"
    //trzeba trzymac otwarte polaczenie
    #ifdef REPLY_WWW
    if (WiFi.status() == WL_CONNECTED)  {    //----- Odpowiedz z WWW
      if ( client.available() ) {
        if ( ! timWwwEnd ) timWwwEnd = micros();
        String line = client.readStringUntil('\n');

    #ifdef DEBUG
        mySerial.println(line);
    #endif
    #ifdef DEBUG_UART0
        Serial.println(line);
    #endif
        char txt[100];
        sprintf( txt, "\n\rRead HTML %d.%02dms", (timWwwEnd - timWwwStat) / 1000, (timWwwEnd - timWwwStat) % 1000 ); printDebug( txt ); // Czas odpowiedzi z WWW
      }
    }
    #endif
  */
}



#define UDP_RX_MAX_SIZE     255
//------------------------------------------------------------
void obsluga_udp() {
  uint32_t static CzasDoUDP;
  char incomingPacket[UDP_RX_MAX_SIZE];


  int packetSize = Udp.parsePacket();
  if ( packetSize ) {
#ifdef DEBUG_UART1
    Serial1.printf( ANSI_PEN_GREEN"\n\r***Received %d bytes from %s, port %d", packetSize, Udp.remoteIP().toString().c_str(), Udp.remotePort() );
#endif
    int len = Udp.read(incomingPacket, UDP_RX_MAX_SIZE);
    if (len > 0)
    {
      incomingPacket[len] = '\0';
    }
#ifdef DEBUG_UART1
    Serial1.printf( "\n\rUDP packet contents: %s\n"ANSI_PEN_WHITE, incomingPacket );
#endif


    /*
          //todo: funkcja szukajaca "\n\r" lub "\r\n" jak nie to "\r" lub "\n" i umieszczajaca kolejno znalezione rekordy w tablicy
          char static rekordy[20][32];
          uint8_t r = 0;
          for (uint16_t x = 0; x < strlen(incomingPacket); x++) {
            if ( ! strncmp( incomingPacket + x, "\n\r", 2 ) ) {
              printDebug( "+" );
              strcpy( rekordy[ r++ ], incomingPacket + x );   // String do tablicy
            }
          }
          for( uint8_t x=0; x<r; x++){
            char txt[100];
            sprintf( txt, "\n\rR%d=%s", x, rekordy[ x ] ); printDebug( txt );
          }
          //todo: w rekordach wyszukiwanie ": " lub "="
    */


    //----- Potwierdzenie odbioru -----//
    //    if ( strncmp( incomingPacket, "ACK:", 4) ) {    // Jesli nie ACK
    if ( false ) {
      printDebug( "Send ACK " );
      uint32_t static id;
      sscanf( incomingPacket + 4 , "%08x", &id );   // odczytanie ID z ramki
      //----- Potwierdzenie -----//
      Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
      Udp.write( "\n\rACK: " );
      char txt[100];
      sprintf( txt, "%08x ", id ); Udp.write( txt );   // ID ramki
      printDebug( txt );
      Udp.write( WiFi.localIP().toString().c_str() );
      Udp.endPacket();

    }


  }


  //----- Nadawanie UDP -----//
  if ( millis() > CzasDoUDP ) {
    CzasDoUDP = millis() + Co_ILE_NA_UDP + random( 0, 500 );
#ifdef DEBUG_UART1
    printDebug( ANSI_PEN_YELLOW"\n\r*** Send UDP ... "ANSI_PEN_WHITE );
#endif

    Udp.beginPacket( BROADCAST, localUdpPort );
    uint32_t static nr;
    char txt[100];
    sprintf( txt, "ID: %08x\n\r", ++nr ); Udp.write( txt ); // Nr ramki
    Udp.write( "NAME: Warsztat\n\r" );                        // Nazwa (opis)
    //Udp.write( WiFi.localIP().toString().c_str() );
    Udp.write( "TYPE: Licznik Orno\n\r" );              // Nazwa urzadzenia
    int8_t static cnt;
    sprintf( txt, "T  =%0.2f*C\n\r", (float)cnt); Udp.write( txt );
    sprintf( txt, "T  =%0.2f*C\n\r", (float)(cnt * 2) ); Udp.write( txt );
    sprintf( txt, "bar=%0.2fhPa\n\r", (float)(cnt * 10) ); Udp.write( txt );
    sprintf( txt, "H  =%0.2f%%\n\r", (float)(cnt) ); Udp.write( txt );
    cnt++;
    uint32_t tim = micros();
    Udp.endPacket();
    sprintf( txt, " %dus", micros() - tim ); printDebug( txt );
  }


}


//------------------------------------------------------------
void obsluga_thingspeak() {

  if ( ! ee.fl_ThingOn ) return;


  if (WiFi.status() == WL_CONNECTED)  {
    if ( millis() > CzasDoTHINGSPEAK && rdORNOfull >= LICZBA_PYTAN_ORNO ) {
      CzasDoTHINGSPEAK = millis() + Co_ILE_NA_THINGSPEAK + random( 0, 1000 );

      printDebug( ANSI_PEN_YELLOW"\n\rSend Thingspeak..."ANSI_PEN_WHITE );
      LedOn( LED_B );
      LedOff( LED_SCK );

      //-----
      uint32_t tim = millis();
      ThingSpeak.setField(1, (float)(WspolczynnikMocy) / 1000 );
      ThingSpeak.setField(2, (float)MocCzynna );
      ThingSpeak.setField(3, (float)MocBierna );
      ThingSpeak.setField(4, (float)MocPozorna );
      ThingSpeak.setField(5, (float)(Prad) / 1000 );
      ThingSpeak.setField(6, (float)(Napiecie) / 100 );
      ThingSpeak.setField(7, (float)(Czestotliwosc) / 100 );
      if ( ip[3] == 52 ) {
        ThingSpeak.writeFields(thingspeak_myChannelNumber, thingspeak_apiKey_1);
      }
      else if ( ip[3] == 53 ) {
        ThingSpeak.writeFields(thingspeak_myChannelNumber, thingspeak_apiKey_2);
      }
      else if ( ip[3] == 54 ) {
        //todo: Uzupełnić !!! jak uzywany wykre
      }
      char txt[50];
      sprintf( txt, " %dms", millis() - tim ); printDebug( txt );
    }
    LedBlink( LED_B, TIM_BLINK_RUN );     //----- Miganie diody RUN -----//
    LedBlink( LED_SCK, TIM_BLINK_RUN );     //----- Miganie diody RUN -----//
  }
}


//------------------------------------------------------------
void aktualizujRTC() {
  uint32_t static tim;

  uint32_t ad, r, ms = millis();
  if ( ms >= tim ) {
    ad = (ms - tim) / 1000;   // liczba sekund od poprzedniego wywolania funkcji (najczesciej zero, chyba, ze loop trwal >= 2 sekundy)
    r = (ms - tim) % 1000;    // reszta ms od poprzedniego wywolania funkcji
    dtSS += ad;               // Dodajemy roznice sekund gdy loop >= 2 sekundy
    tim = ms + 1000 - r;      // Tick + sekunda - reszta

    //----- Standardowy RTC -----//
    if ( ++dtSS >= 60 ) {
      dtSS -= 60;
      if ( ++dtMM >= 60 ) {
        dtMM = 0;
        if ( ++dtGG >= 24 ) { // Zmiane czasu sobie darujemy, nie po to jest NTP
          dtGG = 0;
          dtDD++;
          if ( (dtMIES == 1 && dtDD > 31) ||      // Liczba dni zalezy od miesiaca, lata przestepne sobie darujemy, nie po to jest NTP
               (dtMIES == 2 && dtDD > 28) ||
               (dtMIES == 3 && dtDD > 31) ||
               (dtMIES == 4 && dtDD > 30) ||
               (dtMIES == 5 && dtDD > 31) ||
               (dtMIES == 6 && dtDD > 30) ||
               (dtMIES == 7 && dtDD > 31) ||
               (dtMIES == 8 && dtDD > 31) ||
               (dtMIES == 9 && dtDD > 30) ||
               (dtMIES == 10 && dtDD > 31) ||
               (dtMIES == 11 && dtDD > 30) ||
               (dtMIES == 3 && dtDD > 31)
             ) {
            dtDD = 1;
            if ( ++dtMIES > 12 ) dtYYYY++;
          }
        }
      }
    }
#ifdef DEBUG_RTC
    char txt[100];
    sprintf( txt, " [%d-%d-%02d %d:%02d:%02d] ", dtYYYY, dtMIES, dtDD, dtGG, dtMM, dtSS ); printDebug( txt );
#endif
  }
}


//===========================================================
void loop() {
  ESP.wdtFeed();


  SterujLedy();


  //----- Pomiar czasu trwania petli glownej -----//
  uint32_t static tim, timprint;
  if ( ! tim ) tim = micros(); // Init przy pierwszym obiegu petli

  TimLoop = micros() - tim;
  tim = micros();
  if ( TimLoop > TimLoopMax ) TimLoopMax = TimLoop;

  if ( millis() >= timprint ) {
    timprint = millis() + 5000;
    char txt[100];
    uint32_t tmax = TimLoopMax / 1000;
    sprintf( txt, ANSI_PEN_BLUE"\r\nLoop=%dus Max=%d.%03dsek", TimLoop, tmax / 1000, tmax % 1000 ); printDebug( txt );
    sprintf( txt, " rdORNOfull=%d\n\r"ANSI_PEN_WHITE, rdORNOfull ); printDebug( txt );
  }


  //----- Resetowanie modulu co 24h -----//
  if ( millis() > CzasDoResetu ) {
    printDebug( ANSI_PEN_RED"\n\r\n\r*** Abort ***");
    while ( Serial.availableForWrite() );
    abort();
  }
  /*
    if ( millis() > CzasDoRstWifi ) {
      millis() + DEF_RESTART_WIFI;

      Serial.println("***** Restart Wi-Fi *****");
      disconnect
      po kilkun sekundach connect
      WiFi.begin();
    }
  */


  //----- Wznawianie Wi-Fi gdy rozlaczone -----??
  if (WiFi.status() != WL_CONNECTED) Find_WiFi();
  if (localServer.hasClient()) {
    if (!localClient.connected()) {
      if (localClient) localClient.stop();
      localClient = localServer.available();
    }
  }
  //todo: WiFi.restart();


  //----- Zadania glowne -----//
  ustalanieTypuLicznika();

  Zapytania_Do_Orno();

  WiFi_do_Uart();
  Uart_do_Wifi();

  obsluga_ntp();

  obsluga_thingspeak();
  obsluga_www();
  obsluga_udp();


  aktualizujRTC();


  if ( millis() < timeoutAskOrno ) ornoOnLine = true; else ornoOnLine = false;

  if ( ornoOnLine ) {
    if ( rdORNOfull >= LICZBA_PYTAN_ORNO ) LedOn( LED_G );
    else LedBlink( LED_G, 100 );
  }
  else {
    LedOff( LED_G );
  }


  //----- TESTY -----//
  /*
    //todo: test: serial1
    uint32_t static timSerTx;
    if ( millis() >= timSerTx ) {
    timSerTx = millis() + 3000;

    Serial1.println("test");
    //mySerial.println("Hello, world?");
    }
  */
  //if (mySerial.available())Serial.write(mySerial.read());
  /*
    if ( Serial1.available() ) {
    size_t len = Serial1.available();
    uint8_t sbuf[len];
    Serial1.readBytes(sbuf, len);
    Serial.print(sbuf);
    }
  */


}//----- EMD loop()
